from pathlib import Path
from threading import Thread

import pytest
from pyftpdlib.authorizers import DummyAuthorizer
from pyftpdlib.handlers import TLS_FTPHandler
from pyftpdlib.servers import FTPServer


@pytest.fixture
def ftp_server():
    authorizer = DummyAuthorizer()
    authorizer.add_user("user", "12345", ".", perm="elradfmwMT")
    authorizer.add_anonymous(".")
    handler = TLS_FTPHandler
    handler.certfile = str(Path(__file__).parent / "key.pem")
    handler.authorizer = authorizer
    server = FTPServer(("0.0.0.0", 2121), handler)
    thread = Thread(target=server.serve_forever)
    thread.daemon = True
    thread.start()
    yield
